Index: /trunk/src/cf_mutex.c
===================================================================
--- /trunk/src/cf_mutex.c	(revision 150)
+++ /trunk/src/cf_mutex.c	(revision 151)
@@ -21,6 +21,6 @@
 #endif // #if defined(_WIN32) || defined(_WIN64)
 
-#define ASSERT_MUTEX_CTX(__ctx)	\
-	if (__ctx == NULL)			\
+#define ASSERT_CTX(__ctx)	\
+	if (__ctx == NULL)		\
 		return CF_ERROR_MUTEX_INVALID_CTX
 
@@ -38,5 +38,5 @@
  */
 int
-CF_Mutex_CreateCtx (CF_Mutex_Ctx * ctx)
+CF_Mutex_Create (cf_ctx * ctx)
 {
 	int result = 0;
@@ -44,5 +44,7 @@
 	CF_MUTEX_CONTEXT * context = NULL;
 
-	context = (CF_MUTEX_CONTEXT *) calloc (sizeof (CF_MUTEX_CONTEXT), 1);
+	ASSERT_CTX (ctx);
+
+	context = NEWCTX (CF_MUTEX_CONTEXT);
 	if (context == NULL)
 		return CF_ERROR_MUTEX_CREATE_CTX;
@@ -70,5 +72,5 @@
 	CATCH_IF (result < 0)
 	{
-		CF_Mutex_DestoryCtx ((CF_Mutex_Ctx) context);
+		CF_Mutex_Destory ((cf_ctx) context);
 	}
 
@@ -84,9 +86,9 @@
  */
 int
-CF_Mutex_DestoryCtx (CF_Mutex_Ctx ctx)
+CF_Mutex_Destory (cf_ctx ctx)
 {
-	CF_MUTEX_CONTEXT * context = ctx;
+	CF_MUTEX_CONTEXT * context = (CF_MUTEX_CONTEXT *) ctx;
 
-	ASSERT_MUTEX_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
@@ -112,9 +114,9 @@
  */
 int
-CF_Mutex_Lock (CF_Mutex_Ctx ctx)
+CF_Mutex_Lock (cf_ctx ctx)
 {
-	CF_MUTEX_CONTEXT * context = ctx;
+	CF_MUTEX_CONTEXT * context = (CF_MUTEX_CONTEXT *) ctx;
 
-	ASSERT_MUTEX_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
@@ -135,9 +137,9 @@
  */
 int
-CF_Mutex_Unlock (CF_Mutex_Ctx ctx)
+CF_Mutex_Unlock (cf_ctx ctx)
 {
-	CF_MUTEX_CONTEXT * context = ctx;
+	CF_MUTEX_CONTEXT * context = (CF_MUTEX_CONTEXT *) ctx;
 
-	ASSERT_MUTEX_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
Index: /trunk/src/cf_queue.c
===================================================================
--- /trunk/src/cf_queue.c	(revision 150)
+++ /trunk/src/cf_queue.c	(revision 151)
@@ -8,7 +8,32 @@
 #include "cf_queue.h"
 #include "cf_list.h"
+#include "cf_local.h"
 #include "cf_error.h"
 
 #include <stdio.h>
+
+static int
+CF_Queue_Local_Get (cf_ctx	ctx,
+					void	** element,
+					CF_BOOL	removeFlag)
+{
+	int				result = 0;
+	cf_ctx			list = (cf_ctx) ctx;
+	cf_traverser	trav = NULL;
+
+	result = CF_List_Front (list, &trav);
+	if (result < 0)
+		return result;
+
+	result = CF_List_Get (trav, element);
+	if (result < 0)
+		return result;
+
+	result = (removeFlag == CF_TRUE)
+		   ? CF_List_Remove (ctx, &trav)
+		   : CF_OK;
+
+	return result;
+}
 
 /**
@@ -20,7 +45,7 @@
  */
 int
-CF_Queue_CreateCtx (CF_Queue_Ctx * ctx)
+CF_Queue_Create (cf_ctx * ctx)
 {
-	return CF_List_CreateCtx ((CF_List_Ctx *) ctx);
+	return CF_List_Create ((cf_ctx *) ctx);
 }
 
@@ -33,7 +58,7 @@
  */
 int
-CF_Queue_DestroyCtx (CF_Queue_Ctx ctx)
+CF_Queue_Destroy (cf_ctx ctx)
 {
-	return CF_List_DestroyCtx (ctx);
+	return CF_List_Destroy (ctx);
 }
 
@@ -47,16 +72,10 @@
  */
 int
-CF_Queue_Put (CF_Queue_Ctx	ctx,
+CF_Queue_Put (cf_ctx		ctx,
 			  const void	* element)
 {
-	int				result = 0;
-	CF_List_Ctx		list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
+	cf_ctx list = (cf_ctx) ctx;
 
-	result = CF_List_Rear (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_Insert (list, traverser, CF_DIRECTION_AFTER, element);
+	return CF_List_AddRear (list, element);
 }
 
@@ -70,20 +89,8 @@
  */
 int
-CF_Queue_Get (CF_Queue_Ctx	ctx,
-			  void			** element)
+CF_Queue_Get (cf_ctx	ctx,
+			  void		** element)
 {
-	int			result = 0;
-	CF_List_Ctx	list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
-
-	result = CF_Queue_Front (ctx, element);
-	if (result < 0)
-		return result;
-
-	result = CF_List_Front (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_Remove (ctx, &traverser);
+	return CF_Queue_Local_Get (ctx, element, CF_TRUE);
 }
 
@@ -97,16 +104,8 @@
  */
 int
-CF_Queue_Front (CF_Queue_Ctx 	ctx,
-				void			** element)
+CF_Queue_Front (cf_ctx 	ctx,
+				void	** element)
 {
-	int				result = 0;
-	CF_List_Ctx		list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
-
-	result = CF_List_Front (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_GetElement (traverser, element);
+	return CF_Queue_Local_Get (ctx, element, CF_FALSE);
 }
 
@@ -119,6 +118,6 @@
  */
 int
-CF_Queue_GetSize (CF_Queue_Ctx ctx)
+CF_Queue_GetSize (cf_ctx ctx)
 {
-	return CF_List_GetSize ((CF_List_Ctx) ctx);
+	return CF_List_GetSize ((cf_ctx) ctx);
 }
Index: /trunk/src/cf_socket.c
===================================================================
--- /trunk/src/cf_socket.c	(revision 150)
+++ /trunk/src/cf_socket.c	(revision 151)
@@ -9,4 +9,5 @@
 #include "cf_local.h"
 #include "cf_error.h"
+#include "cf_util.h"
 
 #include <stdio.h>
@@ -33,6 +34,18 @@
 #endif
 
+#define ASSERT_CTX(__ctx)	\
+	if (__ctx == NULL)		\
+		return CF_ERROR_SOCKET_INVALID_CTX
+
+#define ASSERT_ARGS(x)	\
+	if ((x))			\
+		return CF_ERROR_SOCKET_INVALID_ARGS
+
 #define ASSERT_INIT()					\
 	if (!CF_Socket_IsInitialized ())	\
+		return CF_ERROR_SOCKET_NOT_INITIALIZED 
+
+#define TRY_INIT()					\
+	if (CF_Socket_Initialize ())	\
 		return CF_ERROR_SOCKET_NOT_INITIALIZED 
 
@@ -45,10 +58,18 @@
 # define sa_family_t		unsigned short
 # define close(__sock)		closesocket(__sock)
-# define GET_SYSTEM_ERROR()	WSAGetLastError ()
 # define ERROR_INTR			WSAEINTR
 #else
-# define GET_SYSTEM_ERROR()	errno
 # define ERROR_INTR			EINTR
 #endif
+
+#define MAX_IP_LENGTH	256
+
+typedef struct __cf_socket_ctx__
+{
+	int				sock;
+	int				timeout;
+	char			ip[MAX_IP_LENGTH];
+	unsigned short	port;
+} CF_SOCKET_CONTEXT;
 
 static CF_BOOL gInitialized = CF_FALSE;
@@ -64,8 +85,6 @@
 	int flags = fcntl (sock, F_GETFL, 0);
 
-	if (boolean)
-		flags |=  O_NONBLOCK;
-	else
-		flags &= ~O_NONBLOCK;
+	if (boolean)	flags |=  O_NONBLOCK;
+	else			flags &= ~O_NONBLOCK;
 
 	fcntl (sock, F_SETFL, flags);
@@ -74,148 +93,8 @@
 
 static int
-CF_Socket_Local_SetLinger (const int sock)
-{
-	struct linger linger;
-
-	linger.l_onoff = 1;
-	linger.l_linger = 0;
-
-	return CF_Socket_SetOption (sock,
-								SO_LINGER,
-								&linger,
-								sizeof (linger));
-}
-
-static int
-CF_Socket_Local_SetReUseAddr (const int sock)
-{
-	int reuseaddr = 1;
-
-	return CF_Socket_SetOption (sock,
-								SO_REUSEADDR,
-								&reuseaddr,
-								sizeof (reuseaddr));
-}
-
-static int
-CF_Socket_Local_CheckTimeout (const int	sock,
-							  const int	timeout)
-{
-	int				result = 0;
-	fd_set			readfds;
-	struct timeval	tv;
-	int				error;
-
-	if (!(timeout > CF_SOCKET_NO_TIMEOUT))
-		return CF_OK;
-
-	tv.tv_sec = timeout;
-	tv.tv_usec = 0;
-
-	FD_ZERO (&readfds);
-	FD_SET (sock, &readfds);
-
-	while ((result = select (sock + 1, &readfds, NULL, NULL, &tv)) < 0)
-	{
-		error = GET_SYSTEM_ERROR ();
-		if (error != ERROR_INTR)
-		{
-			result = CF_ERROR_SOCKET_TIMEOUT;
-			return result;
-		}
-	}
-
-	if (FD_ISSET (sock, &readfds) == 0)
-	{
-		return CF_ERROR_SOCKET_INTERNAL;
-	}
-
-	return CF_OK;
-}
-
-/**
- * 소켓의 초기화 상태 확인
- *
- * \return 초기화 된 경우, CF_TRUE; 그렇지 않은 경우, CF_FALSE
- */
-CF_BOOL
-CF_Socket_IsInitialized (void)
-{
-	return gInitialized;
-}
-
-/**
- * 소켓 초기화
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- */
-int
-CF_Socket_Initialize (void)
-{
-#if defined(_WIN32) || defined(_WIN64)
-	WSADATA winsockData;
-	if (WSAStartup (MAKEWORD (2, 0), &winsockData))
-	   return CF_ERROR_SOCKET_INITIALIZE;
-#endif
-	gInitialized = CF_TRUE;
-	
-	return CF_OK;
-}
-
-/**
- * 소켓 해제
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- */
-int
-CF_Socket_Finalize (void)
-{
-	ASSERT_INIT ();
-
-#if defined(_WIN32) || defined(_WIN64)
-   	if (WSACleanup ())
-	   return CF_ERROR_SOCKET_FINALIZE;
-#endif
-
-	return CF_OK;
-}
-
-/**
- * 소켓 닫기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param sock 소켓
- */
-int
-CF_Socket_Close (const int sock)
-{
-	int result = 0;
-
-	ASSERT_SOCKET (sock);
-
-	result = close (sock);
-
-	if (result != 0)
-		return CF_ERROR_SOCKET_CLOSE;
-
-	return CF_OK;
-}
-
-/**
- * 소켓 옵션 설정
- *
- * \return 성공 시 CF_OK; 실패 시, 오류 코드
- *
- * \param sock		소켓
- * \param optname	옵션 이름
- * \param optval	설정할 옵션 값의 메모리
- * \param optlen	설정할 옵션의 길이
- */
-int
-CF_Socket_SetOption (const int		sock,
-					 const int		optname,
-					 const void		* optval,
-					 const size_t	optlen)
+CF_Socket_Local_SetOption (const int	sock,
+						   const int	optname,
+						   const void	* optval,
+						   const size_t	optlen)
 {
 	int	result = 0;
@@ -238,19 +117,9 @@
 }
 
-/**
- * 소켓 옵션 얻기
- *
- * \return 성공 시 CF_OK; 실패 시, 오류 코드
- *
- * \param sock		소켓
- * \param optname	옵션 이름
- * \param optval	옵션 값을 가져올 메모리
- * \param optlen	옵션 길이를 가져올 메모리
- */
-int
-CF_Socket_GetOption (const int	sock,
-					 const int	optname,
-					 void		* optval,
-					 size_t		* optlen)
+static int
+CF_Socket_Local_GetOption (const int	sock,
+						   const int	optname,
+						   void			* optval,
+						   size_t		* optlen)
 {
 	int	result = 0;
@@ -273,37 +142,203 @@
 }
 
+static int
+CF_Socket_Local_SetLinger (const int sock)
+{
+	struct linger linger;
+
+	linger.l_onoff = 1;
+	linger.l_linger = 0;
+
+	return CF_Socket_Local_SetOption (sock,
+									  SO_LINGER,
+									  &linger,
+									  sizeof (linger));
+}
+
+static int
+CF_Socket_Local_SetReUseAddr (const int sock)
+{
+	int reuseaddr = 1;
+
+	return CF_Socket_Local_SetOption (sock,
+									  SO_REUSEADDR,
+									  &reuseaddr,
+									  sizeof (reuseaddr));
+}
+
+static int
+CF_Socket_Local_CheckTimeout (const int	sock,
+							  const int	timeout)
+{
+	int				result = 0;
+	fd_set			readfds;
+	struct timeval	tv;
+	int				error;
+
+	if (timeout <= CF_SOCKET_NO_TIMEOUT)
+		return CF_OK;
+
+	tv.tv_sec = timeout;
+	tv.tv_usec = 0;
+
+	FD_ZERO (&readfds);
+	FD_SET (sock, &readfds);
+
+	while ((result = select (sock + 1, &readfds, NULL, NULL, &tv)) < 0)
+	{
+		error = CF_Util_GetSystemError ();
+		if (error != ERROR_INTR)
+		{
+			result = CF_ERROR_SOCKET_TIMEOUT;
+			return result;
+		}
+	}
+
+	if (FD_ISSET (sock, &readfds) == 0)
+		return CF_ERROR_SOCKET_CHECK_DESC_SET;
+
+	return CF_OK;
+}
+
+/**
+ * 소켓의 초기화 상태 확인
+ *
+ * \return 초기화 된 경우, CF_TRUE; 그렇지 않은 경우, CF_FALSE
+ */
+static CF_BOOL
+CF_Socket_IsInitialized (void)
+{
+	return gInitialized;
+}
+
+/**
+ * 소켓 초기화
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ */
+int
+CF_Socket_Initialize (void)
+{
+	if (!CF_Socket_IsInitialized ())
+	{
+#if defined(_WIN32) || defined(_WIN64)
+		WSADATA winsockData;
+		if (WSAStartup (MAKEWORD (2, 0), &winsockData))
+			return CF_ERROR_SOCKET_INITIALIZE;
+#endif
+		gInitialized = CF_TRUE;
+	}
+	
+	return CF_OK;
+}
+
+/**
+ * 소켓 해제
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ */
+int
+CF_Socket_Finalize (void)
+{
+	ASSERT_INIT ();
+
+#if defined(_WIN32) || defined(_WIN64)
+   	if (WSACleanup ())
+	   return CF_ERROR_SOCKET_FINALIZE;
+#endif
+
+	return CF_OK;
+}
+
+/**
+ * 소켓 컨텍스트 생성
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	소켓 컨텍스트
+ */
+int
+CF_Socket_Create (cf_ctx * ctx)
+{
+	int result = 0;
+
+	CF_SOCKET_CONTEXT * context = NULL;
+
+	ASSERT_CTX (ctx);
+
+	TRY
+	{
+		context = NEWCTX (CF_SOCKET_CONTEXT);
+		if (context == NULL)
+		{
+			result = CF_ERROR_SOCKET_CREATE_CTX;
+			TRY_BREAK;
+		}
+
+		context->sock = socket (PF_INET, SOCK_STREAM, IPPROTO_TCP);
+		if (context->sock < 0)
+		{
+			result = CF_ERROR_SOCKET_CREATE;
+			TRY_BREAK;
+		}
+
+		context->timeout = CF_SOCKET_NO_TIMEOUT;
+		*ctx = (CF_SOCKET_CONTEXT *) context;
+	}
+	CATCH_IF (result < 0)
+	{
+		CF_Socket_Close (context);
+	}
+
+	return result;
+}
+
+/**
+ * 소켓 닫기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	소켓 컨텍스트
+ */
+int
+CF_Socket_Close (cf_ctx ctx)
+{
+	int result = 0;
+	int sock = 0;
+
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_SOCKET (context->sock);
+
+	sock = context->sock;
+
+	free (context);
+
+	result = close (sock);
+
+	if (result != 0)
+		return CF_ERROR_SOCKET_CLOSE;
+
+	return CF_OK;
+}
+
 /**
  * 소켓 연결
  *
- * \return 성공 시, 연결된 소켓; 실패 시, 오류 코드
- *
- * \param ip		연결할 호스트의 주소 (도메인 이름 가능)
- * \param port		연결할 호스트의 포트번호
- */
-int
-CF_Socket_Connect (const char			* ip,
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	소켓 컨텍스트
+ * \param ip	연결할 호스트의 주소 (도메인 이름 가능)
+ * \param port	연결할 호스트의 포트번호
+ */
+int
+CF_Socket_Connect (cf_ctx				ctx,
+				   const char			* ip,
 				   const unsigned short	port)
-{
-	return CF_Socket_ConnectTimeout (ip, port, CF_SOCKET_NO_TIMEOUT);
-}
-
-/**
- * 타임아웃 동안 소켓 연결
- *
- * \return 성공 시, 연결된 소켓; 실패 시, 오류 코드
- *
- * \param ip		연결할 호스트의 주소 (도메인 이름 가능)
- * \param port		연결할 호스트의 포트번호
- * \param timeout	타임아웃 (초)
- *
- * \see CF_SOCKET_NO_TIMEOUT
- */
-int
-CF_Socket_ConnectTimeout (const char			* ip,
-						  const unsigned short	port,
-						  const int				timeout)
 {
 	int					result = 0;
 	int					sock = 0;
+	int					timeout = 0;
 	struct sockaddr_in	address;
 	struct hostent		* hostEnt;
@@ -315,10 +350,14 @@
 	fd_set				writefds;
 
-	ASSERT_INIT ();
-
-	/* 1. create socket */
-	sock = socket (PF_INET, SOCK_STREAM, IPPROTO_TCP);
-	if (sock < 0)
-		return CF_ERROR_SOCKET_CREATE;
+	CF_SOCKET_CONTEXT	* context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (ctx);
+	TRY_INIT ();
+
+	/* 1. get and set socket info. */
+	sock = context->sock;
+	snprintf (context->ip, sizeof (context->ip), "%s", ip);
+	context->port = port;
+	timeout = context->timeout;
 
 	/* 2. set data */
@@ -390,5 +429,5 @@
 			retval = 0;
 
-			result = CF_Socket_GetOption (sock, SO_ERROR, &retval, &length);
+			result = CF_Socket_GetOption (ctx, SO_ERROR, &retval, &length);
 			if (result < 0)
 			{
@@ -410,5 +449,5 @@
 	CATCH_IF (result < 0)
 	{
-		CF_Socket_Close (sock);
+		CF_Socket_Close (ctx);
 		return result;
 	}
@@ -417,5 +456,5 @@
 		CF_Socket_Local_SetNonBlocking (sock, CF_FALSE);
 
-	return sock;
+	return result;
 }
 
@@ -423,11 +462,13 @@
  * 서버 열기
  *
- * \return 성공 시, 서버 소켓; 실패 시, 오류 코드
- *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		소켓 컨텍스트
  * \param port		서버 포트
  * \param backlog	listen 시의 backlog 수
  */
 int
-CF_Socket_Server (const unsigned short	port,
+CF_Socket_Server (cf_ctx				ctx,
+				  const unsigned short	port,
 				  const int				backlog)
 {
@@ -436,9 +477,11 @@
 	struct sockaddr_in	address;
 
-	ASSERT_INIT ();
-
-	sock = socket (PF_INET, SOCK_STREAM, IPPROTO_TCP);
-	if (sock < 0)
-		return CF_ERROR_SOCKET_CREATE;
+	CF_SOCKET_CONTEXT	* context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (ctx);
+	TRY_INIT ();
+
+	sock = context->sock;
+	context->port = port;
 
 	address.sin_family		= AF_INET;
@@ -462,4 +505,8 @@
 		}
 
+		snprintf (context->ip, sizeof (context->ip),
+				  "%s",
+				  inet_ntoa(address.sin_addr));
+
 		result = listen (sock, backlog);
 		if (result < 0)
@@ -471,32 +518,49 @@
 	CATCH_IF (result < 0)
 	{
-		CF_Socket_Close (sock);
-		return result;
-	}
-
-	return sock;
-}
-
-/**
- * 소켓 연결
- *
- * \return 성공 시, 연결된 소켓; 실패 시, 오류 코드
- *
- * \param sock	서버 소켓
- */
-int
-CF_Socket_Accept (const int sock)
-{
-	int					sockClient = 0;
+		CF_Socket_Close (ctx);
+	}
+
+	return result;
+}
+
+/**
+ * 소켓 연결 받기
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		소켓 컨텍스트
+ * \param client	연결을 수락할 client 소켓 컨텍스트
+ */
+int
+CF_Socket_Accept (const cf_ctx	ctx,
+				  cf_ctx		* client)
+{
+	int					result = 0;
 	struct sockaddr_in	address;
 	socklen_t			len = sizeof (address);
 
-	ASSERT_SOCKET (sock);
-
-	sockClient = accept (sock, (struct sockaddr *) &address, &len);
-	if (sockClient < 0)
+	CF_SOCKET_CONTEXT	* clntctx = NULL;
+	CF_SOCKET_CONTEXT	* context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_CTX (client);
+	ASSERT_SOCKET (context->sock);
+
+	result = CF_Socket_Create ((cf_ctx *)&clntctx);
+	if (result < 0)
+		return result;
+
+	close (clntctx->sock);
+
+	clntctx->sock = accept (context->sock, (struct sockaddr *) &address, &len);
+	if (clntctx->sock < 0)
+	{
+		CF_Socket_Close ((cf_ctx *)clntctx);
 		return CF_ERROR_SOCKET_ACCEPT;
-
-	return sockClient;
+	}
+
+	*client = (cf_ctx) clntctx;
+
+	return CF_OK;
 }
 
@@ -506,39 +570,20 @@
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
  *
- * \param sock	소켓
- * \param buf	송신할 데이터
+ * \param ctx	소켓 컨텍스트 * \param buf	송신할 데이터
  * \param len	송신할 데이터의 길이
  */
 int
-CF_Socket_Send (const int		sock,
+CF_Socket_Send (const cf_ctx	ctx,
 				const void		* buf,
 				const size_t	len)
 {
-	return CF_Socket_SendTimeout (sock, buf, len, CF_SOCKET_NO_TIMEOUT);
-}
-
-/**
- * 타임아웃 동안 데이터 송신
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param sock		소켓
- * \param buf		송신할 데이터
- * \param len		송신할 데이터의 길이
- * \param timeout	타임아웃 (초)
- *
- * \see CF_SOCKET_NO_TIMEOUT
- */
-int
-CF_Socket_SendTimeout (const int	sock,
-					   const void	* buf,
-					   const size_t	len,
-					   const int	timeout)
-{
 	int result = 0;
 
-	ASSERT_SOCKET (sock);
-
-	result = (int) send (sock, buf, len, 0);
+	CF_SOCKET_CONTEXT	* context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_SOCKET (context->sock);
+
+	result = (int) send (context->sock, buf, len, 0);
 	if (result != len)
 		return CF_ERROR_SOCKET_SEND;
@@ -552,43 +597,25 @@
  * \return 성공 시, 수신한 데이터의 길이; 실패 시, 오류 코드
  *
- * \param sock	소켓
+ * \param ctx	소켓 컨텍스트
  * \param buf	데이터를 수신할 버퍼
  * \param len	데이터를 수신할 버퍼의 최대 크기
  */
 int
-CF_Socket_Recv (const int		sock,
+CF_Socket_Recv (const cf_ctx	ctx,
 				void			* buf,
 				const size_t	len)
 {
-	return CF_Socket_RecvTimeout (sock, buf, len, CF_SOCKET_NO_TIMEOUT);
-}
-
-/**
- * 타임아웃 동안 데이터 수신
- *
- * \return 성공 시, 수신한 데이터의 길이; 실패 시, 오류 코드
- *
- * \param sock		소켓
- * \param buf		데이터를 수신할 버퍼
- * \param len		데이터를 수신할 버퍼의 최대 크기
- * \param timeout	타임아웃 (초)
- *
- * \see CF_SOCKET_NO_TIMEOUT
- */
-int
-CF_Socket_RecvTimeout (const int	sock,
-					   void			* buf,
-					   const size_t	len,
-					   const int	timeout)
-{
 	int result = 0;
 
-	ASSERT_SOCKET (sock);
-
-	result = CF_Socket_Local_CheckTimeout (sock, timeout);
+	CF_SOCKET_CONTEXT	* context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_SOCKET (context->sock);
+
+	result = CF_Socket_Local_CheckTimeout (context->sock, context->timeout);
 	if (result < 0)
 		return result;
 
-	result = (int) recv (sock, buf, len, 0);
+	result = (int) recv (context->sock, buf, len, 0);
 	if (result < 0)
 		return CF_ERROR_SOCKET_RECV;
@@ -596,2 +623,118 @@
 	return result;
 }
+
+/**
+ * 소켓 옵션 설정
+ *
+ * \return 성공 시 CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		소켓 컨텍스트
+ * \param optname	옵션 이름
+ * \param optval	설정할 옵션 값의 메모리
+ * \param optlen	설정할 옵션의 길이
+ */
+int
+CF_Socket_SetOption (const cf_ctx	ctx,
+					 const int		optname,
+					 const void		* optval,
+					 const size_t	optlen)
+{
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+
+	return CF_Socket_Local_SetOption (context->sock,
+									  optname,
+									  optval,
+									  optlen);
+}
+
+/**
+ * 소켓 옵션 얻기
+ *
+ * \return 성공 시 CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		소켓 컨텍스트
+ * \param optname	옵션 이름
+ * \param optval	옵션 값을 가져올 메모리
+ * \param optlen	옵션 길이를 가져올 메모리
+ */
+int
+CF_Socket_GetOption (const cf_ctx	ctx,
+					 const int		optname,
+					 void			* optval,
+					 size_t			* optlen)
+{
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+
+	return CF_Socket_Local_GetOption (context->sock,
+									  optname,
+									  optval,
+									  optlen);
+}
+
+/**
+ * 소켓 컨텍스트에 타임아웃 설정
+ *
+ * \return CF_OK 반환
+ *
+ * \param ctx		소켓 컨텍스트
+ * \param timeout	설정할 타임아웃 시간
+ */
+int
+CF_Socket_SetTimeOut (cf_ctx	ctx,
+					  int		timeout)
+{
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+
+	context->timeout = timeout;
+
+	return CF_OK;
+}
+
+/**
+ * 소켓 컨텍스트에 타임아웃 설정
+ *
+ * \return 성공 시 CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	소켓 컨텍스트
+ * \param ip	ip 주소를 저장할 충분한 공간의 메모리
+ */
+int
+CF_Socket_GetIP (const cf_ctx	ctx,
+				 char			* ip)
+{
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_ARGS (ip == NULL);
+
+	snprintf (ip, sizeof (context->ip), "%s", context->ip);
+
+	return CF_OK;
+}
+
+/**
+ * 소켓 컨텍스트에 타임아웃 설정
+ *
+ * \return 성공 시 CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	소켓 컨텍스트
+ * \param port	포트 번호 저장할 포인터
+ */
+int
+CF_Socket_GetPort (const cf_ctx		ctx,
+				   unsigned short	* port)
+{
+	CF_SOCKET_CONTEXT * context = (CF_SOCKET_CONTEXT *) ctx;
+
+	ASSERT_ARGS (port == NULL);
+
+	*port = context->port;
+
+	return CF_OK;
+}
Index: /trunk/src/cf_stack.c
===================================================================
--- /trunk/src/cf_stack.c	(revision 150)
+++ /trunk/src/cf_stack.c	(revision 151)
@@ -8,7 +8,32 @@
 #include "cf_stack.h"
 #include "cf_list.h"
+#include "cf_local.h"
 #include "cf_error.h"
 
 #include <stdio.h>
+
+static int
+CF_Stack_Local_Get (cf_ctx	ctx,
+					void	** element,
+					CF_BOOL	removeFlag)
+{
+	int				result = 0;
+	cf_ctx			list = (cf_ctx) ctx;
+	cf_traverser	trav = NULL;
+
+	result = CF_List_Front (list, &trav);
+	if (result < 0)
+		return result;
+
+	result = CF_List_Get (trav, element);
+	if (result < 0)
+		return result;
+
+	result = (removeFlag == CF_TRUE)
+		   ? CF_List_Remove (ctx, &trav)
+		   : CF_OK;
+
+	return result;
+}
 
 /**
@@ -20,7 +45,7 @@
  */
 int
-CF_Stack_CreateCtx (CF_Stack_Ctx * ctx)
+CF_Stack_Create (cf_ctx * ctx)
 {
-	return CF_List_CreateCtx ((CF_List_Ctx *) ctx);
+	return CF_List_Create ((cf_ctx *) ctx);
 }
 
@@ -33,7 +58,7 @@
  */
 int
-CF_Stack_DestroyCtx (CF_Stack_Ctx ctx)
+CF_Stack_Destroy (cf_ctx ctx)
 {
-	return CF_List_DestroyCtx (ctx);
+	return CF_List_Destroy (ctx);
 }
 
@@ -47,16 +72,10 @@
  */
 int
-CF_Stack_Push (CF_Stack_Ctx	ctx,
+CF_Stack_Push (cf_ctx		ctx,
 			   const void	* element)
 {
-	int				result = 0;
-	CF_List_Ctx		list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
+	cf_ctx list = (cf_ctx) ctx;
 
-	result = CF_List_Front (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_Insert (list, traverser, CF_DIRECTION_BEFORE, element);
+	return CF_List_AddFront (list, element);
 }
 
@@ -70,20 +89,8 @@
  */
 int
-CF_Stack_Pop (CF_Stack_Ctx	ctx,
-			  void			** element)
+CF_Stack_Pop (cf_ctx	ctx,
+			  void		** element)
 {
-	int			result = 0;
-	CF_List_Ctx	list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
-
-	result = CF_Stack_Top (ctx, element);
-	if (result < 0)
-		return result;
-
-	result = CF_List_Front (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_Remove (ctx, &traverser);
+	return CF_Stack_Local_Get (ctx, element, CF_TRUE);
 }
 
@@ -97,16 +104,8 @@
  */
 int
-CF_Stack_Top (CF_Stack_Ctx 	ctx,
-			  void			** element)
+CF_Stack_Top (cf_ctx 	ctx,
+			  void		** element)
 {
-	int				result = 0;
-	CF_List_Ctx		list = (CF_List_Ctx) ctx;
-	CF_Traverser	traverser = NULL;
-
-	result = CF_List_Front (list, &traverser);
-	if (result < 0)
-		return result;
-
-	return CF_List_GetElement (traverser, element);
+	return CF_Stack_Local_Get (ctx, element, CF_FALSE);
 }
 
@@ -119,6 +118,6 @@
  */
 int
-CF_Stack_GetSize (CF_Stack_Ctx ctx)
+CF_Stack_GetSize (cf_ctx ctx)
 {
-	return CF_List_GetSize ((CF_List_Ctx) ctx);
+	return CF_List_GetSize ((cf_ctx) ctx);
 }
Index: /trunk/src/cf_thread.c
===================================================================
--- /trunk/src/cf_thread.c	(revision 150)
+++ /trunk/src/cf_thread.c	(revision 151)
@@ -7,4 +7,5 @@
  */
 #include "cf_thread.h"
+#include "cf_local.h"
 #include "cf_error.h"
 
@@ -24,5 +25,5 @@
 #endif // #if defined(_WIN32) || defined(_WIN64)
 
-#define ASSERT_THREAD_CTX(__ctx)	\
+#define ASSERT_CTX(__ctx)	\
 	if (__ctx == NULL)				\
 		return CF_ERROR_THREAD_INVALID_CTX
@@ -47,11 +48,11 @@
  */
 int
-CF_Thread_CreateCtx (CF_Thread_Ctx		* ctx,
-					 CF_Thread_Function	callback,
-					 void				* arg)
+CF_Thread_Create (cf_ctx				* ctx,
+				  CF_Thread_Function	callback,
+				  void					* arg)
 {
 	CF_THREAD_CONTEXT * context = NULL;
 
-	context = (CF_THREAD_CONTEXT *) calloc (sizeof (CF_THREAD_CONTEXT), 1);
+	context = NEWCTX (CF_THREAD_CONTEXT);
 	if (context == NULL)
 		return CF_ERROR_THREAD_CREATE_CTX;
@@ -60,5 +61,5 @@
 	context->arg		= arg;
 
-	*ctx = (CF_Thread_Ctx) context;
+	*ctx = (cf_ctx) context;
 
 	return CF_OK;
@@ -74,6 +75,8 @@
  * \remarks
  * pthread에서 지원되는 스케줄링 정책은 SCHED_OTHER, SCHED_FIFO, SCHED_RR 등이 존재 <br />
- * 일반적으로 설정되는 스케줄링 정책의 기본값은 SCHED_OTHER이며, 솔라리스 환경에서 SCHED_OTHER는 TS(timesharing) 방식으로 명시되어 있음 <br />
- * 그러나 개발 단계에서 테스트된 동작은 SCHED_FIFO와 동일하였으며, 때문에 솔라리스 환경에서는 스케줄링 정책을 SCHED_RR로 명시하도록 함 <br />
+ * 일반적으로 설정되는 스케줄링 정책의 기본값은 SCHED_OTHER이며,
+ * 솔라리스 환경에서 SCHED_OTHER는 TS(timesharing) 방식으로 명시되어 있음 <br />
+ * 그러나 개발 단계에서 테스트된 동작은 SCHED_FIFO와 동일하였으며,
+ * 때문에 솔라리스 환경에서는 스케줄링 정책을 SCHED_RR로 명시하도록 함 <br />
  * <br />
  * 참고 url <br />
@@ -82,5 +85,5 @@
  */
 int
-CF_Thread_Start (CF_Thread_Ctx ctx)
+CF_Thread_Start (cf_ctx ctx)
 {
 	int result = 0;
@@ -88,5 +91,5 @@
 	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
 
-	ASSERT_THREAD_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
@@ -138,9 +141,9 @@
  */
 int
-CF_Thread_DestroyCtx (CF_Thread_Ctx ctx)
+CF_Thread_Destroy (cf_ctx ctx)
 {
 	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
 
-	ASSERT_THREAD_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
@@ -163,5 +166,5 @@
  */
 int
-CF_Thread_Join (CF_Thread_Ctx ctx)
+CF_Thread_Join (cf_ctx ctx)
 {
 	CF_THREAD_CONTEXT * context = (CF_THREAD_CONTEXT *) ctx;
@@ -169,5 +172,5 @@
 	char status[16] = {0x00,};
 
-	ASSERT_THREAD_CTX (ctx);
+	ASSERT_CTX (ctx);
 
 #if defined(_WIN32) || defined(_WIN64)
Index: /trunk/src/cf_util.c
===================================================================
--- /trunk/src/cf_util.c	(revision 151)
+++ /trunk/src/cf_util.c	(revision 151)
@@ -0,0 +1,126 @@
+/**
+ * \file cf_util.c
+ *
+ * \author myusgun <myusgun@gmail.com>
+ *
+ * \brief 유틸 구현
+ */
+#include "cf_util.h"
+#include "cf_error.h"
+
+#include <stdio.h>
+#include <time.h>
+
+#if defined(_WIN32) || defined(_WIN64)
+# include <windows.h>
+#else
+# include <sys/time.h>
+# include <errno.h>
+#endif
+
+#define ASSERT_ARGS(x)	\
+	if ((x))			\
+		return CF_ERROR_UTIL_INVALID_ARGS
+
+#if defined(_WIN32) || defined(_WIN64)
+/* {{{ */
+struct timezone
+{
+	int tz_minuteswest;	/* minutes W of Greenwich */
+	int tz_dsttime;		/* type of dst correction */
+};
+
+static int
+gettimeofday (struct timeval *tv, struct timezone *tz)
+{
+	FILETIME			ft;
+	unsigned __int64	buf =0;
+	//static int tzflag = 0;
+
+	if (NULL != tv)
+	{
+		GetSystemTimeAsFileTime (&ft);
+
+		buf |=	ft.dwHighDateTime;
+		buf <<=	32;
+		buf |=	ft.dwLowDateTime;
+
+		if (buf)
+		{
+			buf /= 10;
+			buf -= ((369 * 365 + 89) * (unsigned __int64) 86400) * 1000000;
+		}
+
+		tv->tv_sec = (long)(buf / 1000000UL);
+		tv->tv_usec = (long)(buf % 1000000UL);
+	}
+
+	/*
+	if (NULL != tz)
+	{
+		if (!tzflag)
+		{
+			_tzset();
+			tzflag++;
+		}
+
+		// Adjust for the timezone west of Greenwich
+		tz->tz_minuteswest = _timezone / 60;
+		tz->tz_dsttime = _daylight;
+	}
+	*/
+
+	return 0;
+}
+/* }}} */
+#endif
+
+int
+CF_Util_GetSystemError (void)
+{
+#if defined(_WIN32) || defined(_WIN64)
+	return WSAGetLastError ();
+#else
+	return errno;
+#endif
+}
+
+int
+CF_Util_GetCurrentTime (CF_UTIL_DATETIME * dt)
+{
+	struct timeval	timeVal;
+	struct tm		* timebuf;
+
+	ASSERT_ARGS (dt == NULL);
+
+	gettimeofday (&timeVal, NULL);
+	timebuf = localtime ((const time_t *)&timeVal.tv_sec);
+
+	dt->year	= timebuf->tm_year + 1900;
+	dt->month	= timebuf->tm_mon + 1;
+	dt->day		= timebuf->tm_mday;
+	dt->week	= timebuf->tm_wday;
+
+	dt->hour	= timebuf->tm_hour;
+	dt->min		= timebuf->tm_min;
+	dt->sec		= timebuf->tm_sec;
+
+	dt->usec	= (int) timeVal.tv_usec;
+
+	return CF_OK;
+}
+
+int
+CF_Util_GetTimeString (const CF_UTIL_DATETIME	* dt,
+					   char						* buffer)
+{
+	ASSERT_ARGS (dt     == NULL);
+	ASSERT_ARGS (buffer == NULL);
+
+	snprintf (buffer, CF_UTIL_DATETIME_LENGTH,
+			  "%04d-%02d-%02d %02d:%02d:%02d.%03d",
+			  dt->year, dt->month, dt->day,
+			  dt->hour, dt->min, dt->sec, dt->usec);
+
+	return CF_OK;
+}
Index: /trunk/src/makefile
===================================================================
--- /trunk/src/makefile	(revision 150)
+++ /trunk/src/makefile	(revision 151)
@@ -20,4 +20,5 @@
 					cf_stack		\
 					cf_bitwise		\
+					cf_util			\
 
 TARGET_NAME		= cf
@@ -46,5 +47,5 @@
 # link
 $(TARGET_PATH)/%.$(EXT_SHARED): $(OBJS)
-	$(LD) $(SHARED_FLAGS) -o $@ $? $(LIBS)
+	$(LD) $(SHARED_FLAGS) -o $@ $(LIBS) $?
 
 $(TARGET_PATH)/%.$(EXT_STATIC): $(OBJS)
@@ -53,9 +54,9 @@
 # compile
 $(OBJ_PATH)/%.o: %.$(SOURCE_TYPE)
-	$(CC) $(CFLAGS) $(CDEFS) $(INCLUDES) -o $@ -c $?
+	$(CC) $(CFLAGS) -c $(CDEFS) $(INCLUDES) -o $@ $?
 
 # doxygen
 $(DOXYGEN_OUTPUT_PATH):
-ifeq ($(DOXYGEN_CREATE),YES)
+ifeq ($(DOXYGEN_CREATE),yes)
 ifeq ($(DOXYGEN),)
 	@echo "doxygen was not found."
@@ -69,5 +70,5 @@
 clean:
 	rm -rf $(TARGET_PATH) $(OBJ_PATH)
-ifeq ($(DOXYGEN_CREATE),YES)
+ifeq ($(DOXYGEN_CREATE),yes)
 	rm -rf $(DOXYGEN_OUTPUT_PATH)
 endif
Index: /trunk/test/codec.c
===================================================================
--- /trunk/test/codec.c	(revision 150)
+++ /trunk/test/codec.c	(revision 151)
@@ -25,7 +25,6 @@
 
 	CF_DEBUG_PRINT (stderr, "= Convert hex to binary =\n");
-	if (CF_Codec_Hex_Decode (encode, bin, &length) < 0) {
-		// error
-	}
+	if (CF_Codec_Hex_Decode (encode, bin, &length) < 0)
+		CF_DEBUG_PRINT (stderr, "error\n");
 	else
 		CF_DEBUG_PRINT_BIN (stderr, bin, length, "bin    : %s\n", bin);
Index: /trunk/test/debug.c
===================================================================
--- /trunk/test/debug.c	(revision 150)
+++ /trunk/test/debug.c	(revision 151)
@@ -8,5 +8,6 @@
 #include <string.h>
 
-void callee3 (void) {
+void callee3 (void)
+{
 	CF_DEBUG_BEGIN_FUNCTION;
 
@@ -18,5 +19,6 @@
 }
 
-void callee2 (void) {
+void callee2 (void)
+{
 	CF_DEBUG_BEGIN_FUNCTION;
 
@@ -28,5 +30,6 @@
 }
 
-void callee1 (void) {
+void callee1 (void)
+{
 	CF_DEBUG_BEGIN_FUNCTION;
 
@@ -38,5 +41,6 @@
 }
 
-int main (void) {
+int main (void)
+{
 	char data[] =
 		"【 曲名 : 사랑하고 있는데 】\n"
Index: /trunk/test/file.c
===================================================================
--- /trunk/test/file.c	(revision 150)
+++ /trunk/test/file.c	(revision 151)
@@ -6,6 +6,8 @@
 #include <stdio.h>
 
-int main (void) {
-	int fd = 0;
+int main (void)
+{
+	cf_ctx fd = 0;
+	int result = 0;
 	char *dir1 = "./dir1/test";
 	char *dir2 = "dir2/test";
@@ -21,6 +23,6 @@
 	}
 
-	fd = CF_File_Create (name);
-	if (fd < 0) {
+	result = CF_File_Open (&fd, name, CF_FILE_CREATE|CF_FILE_RW|CF_FILE_TRUNC);
+	if (result < 0) {
 		// error
 	}
@@ -30,6 +32,6 @@
 	CF_File_Close (fd);
 
-	fd = CF_File_Open (name, CF_FILE_READ);
-	if (fd < 0) {
+	result = CF_File_Open (&fd, name, CF_FILE_READ);
+	if (result < 0) {
 		// error
 	}
